#include-once
#include "AutoItObject.au3"
#include "AO_Collection.au3"

#include <Array.au3>
#CS ----------------------------------------------------------------------------
	AutoIt Version: 3.3.6.1
	Author:         GaRy delaMer
	DDTM-34/DML
	Script Function:
#CE ----------------------------------------------------------------------------
Global $AO_FlagDebug = False, $AO_oComError

Func AO__ComError()
	ConsoleWrite("! COM Error ! Number: 0x" & Hex($AO_oComError.number, 8) & @LF & _
		@ScriptName & "(" & $AO_oComError.scriptline & ", 1)" & _
		" - " & $AO_oComError.windescription & @LF)
EndFunc

;	AutoItObjetct: Enum
Func AO_Enum($NextFunction = "", $ResetFunction = "", $SkipFunction = "")
	Local $AO_Class = _AutoItObject_Class()
	;;;	Destructor
	$AO_Class.AddDestructor("AO_Enum__Destructor")
	;;;	ReadOnly Properties
	;;;	Private Properties
	;;;	Public Properties
	$AO_Class.AddProperty("ParentName", $ELSCOPE_PUBLIC)
	$AO_Class.AddProperty("NextFunction", $ELSCOPE_PUBLIC, $NextFunction)
	$AO_Class.AddProperty("ResetFunction", $ELSCOPE_PUBLIC, $ResetFunction)
	$AO_Class.AddProperty("SkipFunction", $ELSCOPE_PUBLIC, $SkipFunction)
	;;;	Private Methods
	;;;	Public Methods
	$AO_Class.AddMethod("Debug", "AO_Enum__Debug")
	$AO_Class.AddMethod("GetEnum", "AO_Enum_GetEnum")
	$AO_Class.AddMethod("GetFunctions", "AO_Enum_GetFunctions")
	;;;	Objet: Enum
	Local $Object = $AO_Class.Object
	If $AO_FlagDebug Then $Object.Debug
	Return $Object
EndFunc   ;==>AO_Enum
Func AO_Enum__Debug($Object, $bReturn = False, $ScriptName = @ScriptName, $LineNumber = @ScriptLineNumber)
	Local $Return = StringFormat("NextFunction: '%s', ResetFunction: '%s', SkipFunction: '%s'", _
			$Object.NextFunction, $Object.ResetFunction, $Object.SkipFunction)
	If $AO_FlagDebug Then ConsoleWrite($Return)
	If $bReturn Then Return $Return
	ConsoleWrite($Return)
EndFunc   ;==>AO_Enum__Debug
Func AO_Enum__Destructor($Object)
	ConsoleWrite("Objet 'AO_Enum' dtruit !!!" & @LF)
EndFunc   ;==>AO_Enum__Destructor
Func AO_Enum_GetEnum($Object)
	If $Object.NextFunction And $Object.ResetFunction Then _
			Return StringFormat('$AO_Class.AddEnum("AO_%s_%s", "AO_%s_%s")', _
			$Object.ParentName, $Object.NextFunction, $Object.ParentName, $Object.ResetFunction)
	Return ""
EndFunc   ;==>AO_Enum_GetEnum
Func AO_Enum_GetFunctions($Object)
	Local $Functions = ""
	If $Object.NextFunction Then
		$Functions &= StringFormat("Func AO_%s_%s(ByRef $Object, ByRef $iterator)\n\t#forceref $Object, $iterator\n\t;A crire ici\n\tReturn $iteretor\nEndFunc\n", _
				$Object.ParentName, $Object.NextFunction)
	EndIf
	If $Object.ResetFunction Then
		$Functions &= StringFormat("Func AO_%s_%s(ByRef $Object, ByRef $iterator)\n\t#forceref $Object\n\t$iterator = 0\nEndFunc\n", _
				$Object.ParentName, $Object.ResetFunction)
	EndIf
	Return $Functions
EndFunc   ;==>AO_Enum_GetFunctions


;	AutoItObjetct: Method
Func AO_Method($Name, $bPrivate = False, $Args = "")
	Local $AO_Class = _AutoItObject_Class()
	;;;	Destructor
	$AO_Class.AddDestructor("AO_Method__Destructor")
	;;;	ReadOnly Properties
	;;;	Private Properties
	$AO_Class.AddProperty("_Args", $ELSCOPE_PRIVATE)
	;;;	Public Properties
	$AO_Class.AddProperty("ParentName", $ELSCOPE_PUBLIC)
	$AO_Class.AddProperty("TVItem", $ELSCOPE_PUBLIC)
	$AO_Class.AddProperty("Name", $ELSCOPE_PUBLIC)
	$AO_Class.AddProperty("Function", $ELSCOPE_PUBLIC)
	$AO_Class.AddProperty("Private", $ELSCOPE_PUBLIC, $bPrivate)
	$AO_Class.AddProperty("Code", $ELSCOPE_PUBLIC)
	;;;	Private Methods
	;;;	Public Methods
	$AO_Class.AddMethod("Args", "AO_Method_Args")
	$AO_Class.AddMethod("Debug", "AO_Method__Debug")
	$AO_Class.AddMethod("GetFunction", "AO_Method_GetFunction")
	$AO_Class.AddMethod("GetMethod", "AO_Method_GetMethod")
	;;;	Objet: Method
	Local $Object = $AO_Class.Object
	Local $aName = StringSplit($Name, "|")
	$Object.Name = $aName[1]
	$Object.Function = $aName[1]
	If $aName[0] > 1 Then $Object.Function = $aName[2]
	$Object.Args = $Args
	If $AO_FlagDebug Then $Object.Debug
	Return $Object
EndFunc   ;==>AO_Method
Func AO_Method__Debug($Object, $bReturn = False, $ScriptName = @ScriptName, $LineNumber = @ScriptLineNumber)
	Local $sArgs = "", $aArgs = $Object.Args
	If IsArray($Object.Args) Then $sArgs = _ArrayToString($aArgs, ", ")

	Local $Return = StringFormat("Name: '%s', Private: %s,\n" _
			 & "  Function: AO_%s_%s($Object, %s)", _
			$Object.Name, $Object.Private, _
			$Object.Name, $Object.Function, $sArgs)

	If $AO_FlagDebug Then ConsoleWrite($Return)
	If $bReturn Then Return $Return
	ConsoleWrite($Return)
EndFunc   ;==>AO_Method__Debug
Func AO_Method__Destructor($Object)
	ConsoleWrite("Objet 'AO_Method' dtruit !!!" & @LF)
EndFunc   ;==>AO_Method__Destructor
Func AO_Method_Args($Object, $Args = Default)
	If $Args = Default Then Return $Object._Args
	$Object._Args = $Args
	If $Args = "$Arg = Default" Then
		$Object.Code = @TAB & "If $Arg = Default Then Return $Object._" & $Object.Name & @CRLF & _
				@TAB & "$Object._" & $Object.Name & " = $Arg"
	EndIf
EndFunc   ;==>AO_Method_Arg
Func AO_Method_GetFunction($Object)
	Local $Args = $Object.Args
	If IsArray($Object.Args) Then $Args = _ArrayToString($Args, ", ")
	Return StringFormat("Func AO_%s_%s($Object, %s)\n%s\nEndFunc", _
			$Object.ParentName, $Object.Function, $Args, $Object.Code)
EndFunc   ;==>AO_Method_GetFunction
Func AO_Method_GetMethod($Object)
	Return StringFormat('$AO_Class.AddMethod("%s", "AO_%s_%s", %s)', $Object.Name, $Object.ParentName, $Object.Function, _Iif($Object.Private, True, False))
EndFunc   ;==>AO_Method_GetMethod

;	AutoItObjetct: Methods (collection of method)
Func AO_Methods()
	Local $AO_Class = _oCollection("Methods")
	;;;	Private Properties
	_AutoItObject_AddProperty($AO_Class, "Parent")
	;;;	Public Method
	_AutoItObject_AddMethod($AO_Class, "Add", "AO_Methods_Add")
	_AutoItObject_AddMethod($AO_Class, "Delete", "AO_Methods_Delete")
	;;;	Objet: Properties
	If $AO_FlagDebug Then $AO_Class.Debug(True)
	Return $AO_Class
EndFunc   ;==>AO_Methods
Func AO_Methods_Add($Object, $TVItem, $Name, $bPrivate = False, $Args = "")
	Local $oMethod = AO_Method($Name, $bPrivate, $Args)
	$oMethod.ParentName = $Object.Name
	$oMethod.TVItem = $TVItem
	$Object.Parent.Methods.Push($oMethod)
EndFunc   ;==>AO_Methods_Add
Func AO_Methods_Delete($Object, $Arg)
	Local $iIndex = 0
	For $oProperty In $Object.Parent.Methods
		If $oProperty.TVItem = $Arg Then
			$Object.Parent.Methods.Remove($iIndex)
			ExitLoop
		EndIf
		$iIndex += 1
	Next
EndFunc   ;==>AO_Methods_Delete


;	AutoItObjetct: Property
Func AO_Property($Name, $Scope = "$ELSCOPE_PUBLIC", $Value = Default)
	If $Scope = Default Or $Scope = -1 Or $Scope = "" Then $Scope = "$ELSCOPE_PUBLIC"
	Local $AO_Class = _AutoItObject_Class()
	;;;	Destructor
	$AO_Class.AddDestructor("AO_Property__Destructor")
	;;;	ReadOnly Properties
	;;;	Private Properties
	;;;	Public Properties
	$AO_Class.AddProperty("TVItem", $ELSCOPE_PUBLIC)
	$AO_Class.AddProperty("Name", $ELSCOPE_PUBLIC, $Name)
	$AO_Class.AddProperty("Scope", $ELSCOPE_PUBLIC, $Scope)
	$AO_Class.AddProperty("Value", $ELSCOPE_PUBLIC, $Value)
	;;;	Private Methods
	;;;	Public Methods
	$AO_Class.AddMethod("Debug", "AO_Property__Debug")
	$AO_Class.AddMethod("GetProperty", "AO_Property_GetProperty")
	;;;	Objet: Property
	Local $Object = $AO_Class.Object
	If $AO_FlagDebug Then $Object.Debug
	Return $Object
EndFunc   ;==>AO_Property
Func AO_Property__Destructor($Object)
	ConsoleWrite("Objet 'AO_Property' dtruit !!!" & @LF)
EndFunc   ;==>AO_Property__Destructor
Func AO_Property__Debug($Object, $bReturn = False, $ScriptName = @ScriptName, $LineNumber = @ScriptLineNumber)
	Local $Scope = $Object.Scope
	If $Scope = "" Or $Scope = -1 Then $Scope = "$ELSCOPE_PUBLIC"
	Local $Value = $Object.Value
	If $Value = Default Then $Value = "Default"
	If IsString($Value) Then $Value = "'" & $Value & "'"
	Local $Return = StringFormat('Name: "%s", Scope: %s, Value: %s', $Object.Name, $Scope, $Value)
	If $AO_FlagDebug Then ConsoleWrite($Return)
	If $bReturn Then Return $Return
	ConsoleWrite($Return)
EndFunc   ;==>AO_Property__Debug
Func AO_Property_GetProperty($Object)
	Local $Value = ""
	If $Object.Value = Default Then $Value = ", Default"
	If $Object.Value Then $Value = ", '" & $Object.Value & "'"
	If IsNumber($Object.Value) Then $Value = ", " & $Object.Value
	Return '$AO_Class.AddProperty("' & $Object.Name & '", ' & $Object.Scope & $Value & ')'
EndFunc   ;==>AO_Property_GetProperty

;	AutoItObjetct: Properties (collection of property)
Func AO_Properties()
	Local $AO_Class = _oCollection("Properties")
	;;;	Private Properties
	_AutoItObject_AddProperty($AO_Class, "Parent")
	;;;	Public Method
	_AutoItObject_AddMethod($AO_Class, "Add", "AO_Properties_Add")
	_AutoItObject_AddMethod($AO_Class, "Delete", "AO_Properties_Delete")
	;;;	Objet: Properties
	If $AO_FlagDebug Then $AO_Class.Debug(True)
	Return $AO_Class
EndFunc   ;==>AO_Properties
Func AO_Properties_Add($Object, $TVItem, $Name, $Scope = "$ELSCOPE_PUBLIC", $Value = Default)
	Local $oProperty = AO_Property($Name, $Scope, $Value)
	$oProperty.TVItem = $TVItem
	$Object.Parent.Properties.Push($oProperty)
EndFunc   ;==>AO_Properties_Add
Func AO_Properties_Delete($Object, $Arg)
	Local $iIndex = 0
	For $oProperty In $Object.Parent.Properties
		If $oProperty.TVItem = $Arg Then
			$Object.Parent.Properties.Remove($iIndex)
			ExitLoop
		EndIf
		$iIndex += 1
	Next
EndFunc   ;==>AO_Properties_Delete


;	 AutoItObjetct: ScriptObject
Func AO_ScriptObject($Name = "")
	If ObjEvent("AutoIt.Error") = "" Then _
			$AO_oComError = ObjEvent("AutoIt.Error", "AO__ComError")
	Local $AO_Class = _AutoItObject_Class()
	;;;	Destructor
	$AO_Class.AddDestructor("AO_ScriptObject__Destructor")
	;;;	Private Properties
	;;;	Public Properties
	$AO_Class.AddProperty("Destructor", $ELSCOPE_PUBLIC, False)
	$AO_Class.AddProperty("Includes", $ELSCOPE_PUBLIC, False)
	$AO_Class.AddProperty("Enum", $ELSCOPE_PUBLIC, False)
	$AO_Class.AddProperty("Error", $ELSCOPE_PUBLIC, False)
	$AO_Class.AddProperty("Methods", $ELSCOPE_PUBLIC, AO_Methods())
	$AO_Class.AddProperty("Name", $ELSCOPE_PUBLIC, $Name)
	$AO_Class.AddProperty("Properties", $ELSCOPE_PUBLIC, AO_Properties())
	;;;	ReadOnly Properties
	;;;	Private Methods
	;;;	Public Methods
	$AO_Class.AddMethod("Debug", "AO_ScriptObject__Debug")
	$AO_Class.AddMethod("Code", "AO_ScriptObject_Code")
	$AO_Class.AddMethod("Method", "AO_ScriptObject_Method")
	$AO_Class.AddMethod("Property", "AO_ScriptObject_Property")
	;;;	Objet: ScriptObject
	Local $Object = $AO_Class.Object
	$Object.Methods.Parent = $Object
	$Object.Properties.Parent = $Object
	If $AO_FlagDebug Then $Object.Debug
	Return $Object
EndFunc   ;==>AO_ScriptObject
Func AO_ScriptObject__Destructor($Object)
	ConsoleWrite("Objet 'AO_ScriptObject' dtruit !!!" & @LF)
EndFunc   ;==>AO_ScriptObject__Destructor
Func AO_ScriptObject__Debug($Object, $bReturn = False, $ScriptName = @ScriptName, $LineNumber = @ScriptLineNumber)
	Local $Return = StringFormat("Name: '%s' \nDestructeur: %s\n", _
			$Object.Name, $Object.Destructor)

	$Return &= StringFormat("Properties: %d\n", $Object.Properties.Count)
	For $oProperty In $Object.Properties
		$Return &= "  " & $oProperty.Debug(True) & @LF
	Next

	$Return &= StringFormat("Methods: %d\n", $Object.Methods.Count)
	For $oMethod In $Object.Methods
		$Return &= "  " & $oMethod.Debug(True) & @LF
	Next

	If $AO_FlagDebug Then ConsoleWrite($Return)
	If $bReturn Then Return $Return
	ConsoleWrite($Return)
EndFunc   ;==>AO_ScriptObject__Debug
Func AO_ScriptObject_Code($Object)
	Local $Code
	If $Object.Includes Then $Code = '#Include-Once' & @CRLF & _
			'#Include "AutoItObject.au3"' & @CRLF & _
			'#Include "AO_Collection.au3"' & @CRLF & @CRLF
	$Code &= 'Global $AO_FlagDebug = False'
	If $Object.Error Then $Code &= ', $AO_oComError' & @CRLF & @CRLF & _
			'Func AO__ComError()' & @CRLF & _
			'	ConsoleWrite("! COM Error ! Number: 0x" & Hex($AO_oComError.number, 8) & @LF & _' & @CRLF & _
			'		@ScriptName & "(" & $AO_oComError.scriptline & ", 1)" & _' & @CRLF & _
			'		" - " & $AO_oComError.windescription & @LF)' & @CRLF & _
			'EndFunc'
	$Code &= @CRLF & @CRLF
	$Code &= "Func AO_" & $Object.Name & "()" & @CRLF
	If $Object.Error Then _
			$Code &= @TAB & 'If ObjEvent("AutoIt.Error") = "" Then ' & _
			'$AO_oComError = ObjEvent("AutoIt.Error", "AO__ComError")' & @CRLF & @CRLF
		$Code &= @TAB & "Local $AO_Class = _AutoItObject_Class()" & @CRLF
		$Code &= @TAB & ";;;	Destructor" & @CRLF
		If $Object.Destructor Then $Code &= '	$AO_Class.AddDestructor("AO_' & $Object.Name & '__Destructor")' & @CRLF
		$Code &= @TAB & ";;;	Enum" & @CRLF
		If $Object.Enum Then
			Local $oEnum = AO_Enum("EnumNext", "EnumReset")
			$oEnum.ParentName = $Object.Name
			$Code &= @TAB & $oEnum.GetEnum & @CRLF
		EndIf
		Local $P_PRIVATE = @TAB & ";;;	Private Properties" & @CRLF
		Local $P_PUBLIC = @TAB & ";;;	Public Properties" & @CRLF
		Local $P_READONLY = @TAB & ";;;	Read Only Properties" & @CRLF
		For $oProperty In $Object.Properties
			Switch $oProperty.Scope
				Case "$ELSCOPE_PRIVATE"
					$P_PRIVATE &= @TAB & $oProperty.GetProperty & @CRLF
				Case "$ELSCOPE_READONLY"
					$P_READONLY &= @TAB & $oProperty.GetProperty & @CRLF
				Case Else
					$P_PUBLIC &= @TAB & $oProperty.GetProperty & @CRLF
			EndSwitch
		Next
		$Code &= $P_PRIVATE & $P_PUBLIC & $P_READONLY
		Local $Methods
		Local $M_PRIVATE = @TAB & ";;;	Private Method" & @CRLF
		Local $M_PUBLIC = @TAB & ";;;	Public Method" & @CRLF
		For $oMethod In $Object.Methods
			$oMethod.ParentName = $Object.Name
			Switch $oMethod.Private
				Case True
					$M_PRIVATE &= @TAB & $oMethod.GetMethod & @CRLF
				Case Else
					$M_PUBLIC &= @TAB & $oMethod.GetMethod & @CRLF
			EndSwitch
			$Methods &= $oMethod.GetFunction & @CRLF
		Next
		$Code &= $M_PRIVATE & $M_PUBLIC
		$Code &= @TAB & ';;;	Objet: ' & $Object.Name & @CRLF & _
				@TAB & 'Local $Object = $AO_Class.Object' & @CRLF & _
				@TAB & 'If $AO_FlagDebug Then $Object.Debug' & @CRLF & _
				@TAB & 'Return $Object' & @CRLF
		$Code &= "EndFunc" & @CRLF
		If $Object.Destructor Then $Methods = 'Func AO_' & $Object.Name & '__Destructor($Object)' & @CRLF & _
				@TAB & 'ConsoleWrite("Objet ''AO_' & $Object.Name & ''' dtruit !!!" & @LF)' & @CRLF & _
				'EndFunc' & @CRLF & $Methods
		$Code &= $Methods
		If $Object.Enum Then
			$Code &= $oEnum.GetFunctions
			$oEnum = 0
		EndIf
		Return $Code
EndFunc   ;==>AO_ScriptObject_Code
Func AO_ScriptObject_Method($Object, $TVItem = -1)
	If $Object.Methods.Count = 0 Then Return SetError(1)
	If $TVItem = -1 Then Return $Object.Methods.Last.Data
	For $oMethod In $Object.Methods
		If $oMethod.TVItem = $TVItem Then Return $oMethod
	Next
	Return SetError(2)
EndFunc   ;==>AO_ScriptObject_Method
Func AO_ScriptObject_Property($Object, $TVItem = -1)
	If $Object.Properties.Count = 0 Then Return SetError(1)
	If $TVItem = -1 Then Return $Object.Properties.Last.Data
	For $oProperty In $Object.Properties
		If $oProperty.TVItem = $TVItem Then Return $oProperty
	Next
	Return SetError(2)
EndFunc   ;==>AO_ScriptObject_Property
